//состояние кнопок по умолчанию
bool okSwitchState, longOkSwitchState, ok2xSwitchState;
bool upSwitchState, downSwitchState, cancelSwitchState;


#define pin_B           A8  //CLK
#define pin_A           A9  //DT
#define OkSwitchPin     A10 //SW
#define EncVCC          A11
#define EncGND          A12
#define CancelSwitchPin A13

#include <ClickEncoder.h>
#include <TimerOne.h>
ClickEncoder *encoder;
int16_t lastEnc, valEnc;
byte pinA   = pin_A;
byte pinB   = pin_B;
byte pinBTN = OkSwitchPin;

void timerIsr() { encoder->service(); }

long ms_button = 0;
byte delayKey = 50;

void setup_key() {
//  pinMode (OkSwitchPin,     INPUT_PULLUP);
  pinMode (CancelSwitchPin, INPUT_PULLUP);
  pinMode (EncGND, OUTPUT); digitalWrite (EncGND, LOW);
  pinMode (EncVCC, OUTPUT); digitalWrite (EncVCC, HIGH);
  
  encoder = new ClickEncoder(pinB, pinA, pinBTN, 4);
  Timer1.initialize(1000);
  Timer1.attachInterrupt(timerIsr);
  lastEnc = 0;
}
  
void read_key() // ------- Reading KEY
{
  okSwitchState     = 0;
  longOkSwitchState = 0;
  ok2xSwitchState   = 0;
  upSwitchState     = 0;
  downSwitchState   = 0;
  cancelSwitchState = 0;

  valEnc += encoder->getValue();
  if (valEnc != lastEnc) {
    int iEnc = valEnc - lastEnc;
    lastEnc = valEnc;
    if (iEnc > 0) {
      upSwitchState = true;
      return;
    }
    else {
      downSwitchState = true;
      return;
    }
  }

  ClickEncoder::Button b = encoder->getButton();
  if (b != ClickEncoder::Open) {
    switch (b) {
      case ClickEncoder::Clicked: {
        okSwitchState = true;
        return;        
      }
      case ClickEncoder::DoubleClicked: {
//        ok2xSwitchState = true;
        cancelSwitchState = true;
        return;
      }
      case ClickEncoder::Held: {
        longOkSwitchState = true;
        return;
      }
      break;
    }
  }

  byte CancelSwitch = digitalRead(CancelSwitchPin);
  if (CancelSwitch == HIGH) CancelSwitch = LOW; else CancelSwitch = HIGH;
  if (CancelSwitch == HIGH && (millis() - ms_button) > delayKey / 2) {
    cancelSwitchState = true;
    ms_button = millis();
    return;
  } 
} //end void read_enc

